// #autoload
// #name = UberChat
// #version = 1.4.5
// #date = September 16, 2002
// #author = Paul Tousignant
// #warrior = UberGuy (FT)
// #email = uberguy@tribalwar.com
// #web = http://scripts.tribalwar.com/uberguy
// #web = http://scripts.tribes-universe.com/uberguy
// #readme = scripts/UberGuy/uberChat.txt
// #description = Allows for a wider and more visible chat HUD
// #category = UberGuy's Scripts
// #status = Release
// #config = UberChatGui
// #credit = jsut, for the way to do to upward resizing, and Ungberg|RT, for asking for the feature.
// #include = support/team_tracker.cs
// #include = support/kill_callbacks.cs
// #include = support/PJFontSelector.cs

// #lastdate = Oct 19, 2001

function tuple(%x, %y) {

	return (%x @ " " @ %y);
}

function triple(%x, %y, %z) {

	return (%x @ " " @ %y @ " " @ %z);
}

if(!isObject(uberChat))
{
    new ScriptObject(uberChat)
    {
        class = uberChat;
        colorKills = false;
    };
}

package uberChatWrap {

	function quit() {
		if (!$uberPrefsSaved) {
			uberChat.savePrefs();
			$uberPrefsSaved = 1;
		}
		parent::quit();
	}

	function MessageHud::open(%this) {

		adjustVoteHud();

		%mp = messageHud_Frame.position;
		%me = messageHud_Frame.extent;

		%vp = mainVoteHud.position;
		%ve = mainVoteHud.extent;

		parent::open(%this);

		mainVoteHud.extent = %ve;
		mainVoteHud.position = %vp;

		if ($uberPref::chatSizesUp) {
			%y = getWord(outerChatHud.getGroup().position,1) - 18;
			if (mainVoteHud.isVisible()) %y -= 8;
		}
		else {
			if (mainVoteHud.isVisible())
				%y = getWord(outerChatHud.getGroup().position,1) + getWord(mainVoteHud.position,1) + 7;
			else
				%y = getWord(outerChatHud.getGroup().position,1) + getWord(outerChatHud.getGroup().extent,1);
		}

		if (mainVoteHud.isVisible()) adjustVoteHud();

		if ($uberPref::chatUndockInput) {
			messageHud_Frame.position = %mp;
			messageHud_Frame.extent = %me;
		}
		else {
			%x = getWord(outerChatHud.getGroup().position,0) + getWord(chatHud.position,0);
			messageHud_Frame.position =  %x SPC %y;
		}
   	}

	function MessageHud::close(%this) {

		%mp = messageHud_Frame.position;
		%me = messageHud_Frame.extent;

		%vp = mainVoteHud.position;
		%ve = mainVoteHud.extent;

		parent::close(%this);

		mainVoteHud.extent = %ve;
		mainVoteHud.position = %vp;

		if ($uberPref::chatSizesUp) {
			%y = getWord(outerChatHud.getGroup().position,1) - 18;
			if (mainVoteHud.isVisible()) %y -= 8;
		}
		else {
			if (mainVoteHud.isVisible()) %y = getWord(mainVoteHud.position,1) + 7;
			else %y = getWord(mainVoteHud.position,1);
		}

		if (mainVoteHud.isVisible()) adjustVoteHud();

		if ($uberPref::chatUndockInput) {
			messageHud_Frame.position = %mp;
			messageHud_Frame.extent = %me;
		}
		else {
			%x = getWord(outerChatHud.getGroup().position,0) + getWord(chatHud.position,0);
			messageHud_Frame.position =  %x SPC %y;
		}
   	}

	function adjustVoteHud() {

		if ($uberPref::chatSizesUp) {

			outerChatHud.setPosition(firstWord(outerChatHud.position),9);
			%tempY = getWord(outerChatHud.position, 1) - 7 ;

			mainVoteHud.setPosition(firstWord(outerChatHud.position),%tempY);

			outerChatHud.getGroup().setExtent(
				(firstWord(mainVoteHud.extent) + firstWord(mainVoteHud.position)),
				(getWord(outerChatHud.extent,1) + getWord(outerChatHud.position,1))
			);
		}
		else {

			outerChatHud.setPosition(firstWord(outerChatHud.position),0);
			%tempY = getWord(outerChatHud.position, 1) + getWord(outerChatHud.extent,1) + 2;

			mainVoteHud.setPosition(firstWord(outerChatHud.position),%tempY);

			outerChatHud.getGroup().setExtent(
				(firstWord(outerChatHud.extent) + firstWord(outerChatHud.position)),
				(getWord(mainVoteHud.extent,1) + getWord(mainVoteHud.position,1))
			);
		}
	}

	function openVoteHud(%msgType, %msgString, %numClients, %passPercent) {

		parent::openVoteHud(%msgType, %msgString, %numClients, %passPercent);
		adjustVoteHud();
	}

//	function addYesVote(%msgType, %msgString) {

//		parent::addYesVote(%msgType, %msgString);
//		adjustVoteHud();
//	}

//	function addNoVote(%msgType, %msgString) {
//
//		parent::addNoVote(%msgType, %msgString);
//		adjustVoteHud();
//	}

	function defaultMessageCallback(%msgType, %msgString,
		 %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10) {

		if (uberChat.colorKills && $uberPref::colorKills) {

			%msgs = detag(%msgString);
			%subType = detag(%msgType);

			if (killTypes.isKillType(%subType)) {

				%vict = detag(%a1);
				%kllr = detag(%a4);
				//%myTeam = getClientTeamId(getManagerID());
				%myTeam = teamTracker.friendlyTeamID;

				if (teamTracker.getPlayerTeamId(%vict) == %myTeam)
					%vc = "\c3";
				else
					%vc = "\c5";

				if (teamTracker.getPlayerTeamId(%kllr) == %myTeam)
					%kc = "\c3";
				else
					%kc = "\c5";

				if (%vict !$= "") {
					%msgs = strreplace(%msgs,%vict,%vc@%vict@"\cr");
				}
				if (%kllr !$= "" && %kllr !$= %vict) {
					%msgs = strreplace(%msgs,%kllr,%kc@%kllr@"\cr");
				}
			}
		}
		parent::defaultMessageCallback(%msgType, %msgs,
			%a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
	}

	function clientCmdChatMessage(%sender, %voice, %pitch, %msgString,
		%a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10) {

		%str = detag(%msgString);

//		if ($uberPref::muteFags) {
//
//	        if (detag(%voice) $= "") {
//					// Player is using null-voice exploit, show the message but don't play the sound
//					%wavStart = strstr(%str, "~w");
//				if (%wavStart != -1) %str = getSubStr(%str, 0, %wavStart);
//			}
///		}

		if ($uberPref::stripChatColor || $uberPref::muteChatKeys) {

			%color = getSubStr(%str,0,1);

			if (%color $= "[") {
				%pos = strpos(%str,"]");
				%color = getSubStr(%str,%pos+2,1); //Skip end ] and color code
				%pos+=3;
			}
			else %pos = 0;
			if (!$uberPref::muteChatKeys) {
				if ($uberPref::stripChatColor) {
					%msgString =
						getSubStr(%str,0,%pos) @
						stripChars(getSubStr(%str,%pos,strlen(%str)-%pos),
							"\c0\c1\c2\c3\c4\c5\cr");
				}
				else {	}
			}
			else {
				if ($uberPref::stripChatColor) {
					%msgString = %color @
						stripChars(getSubStr(%str,%pos,strlen(%str)-%pos),
							"\c0\c1\c2\c3\c4\c5\cr");
				}
				else {
					%msgString = %color @
						getSubStr(%str,%pos,strlen(%str)-%pos);
				}
			}
		}
		parent::clientCmdChatMessage(%sender, %voice, %pitch, %msgString,
			%a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
	}

	function MainChatHud::setChatHudLength(%this, %length, %sizeIncrease) {

		%height = getWord(OuterChatHud.extent,1);

		%chatScrollLenY = $uberPref::chatHudLines[%length] * ChatHud.profile.fontSize;
		%outerChatLenY = %chatScrollLenY + 8;

		%outerChatLenX = firstWord(outerChatHud.extent);
		%chatScrollLenX = firstWord(chatScrollHud.extent);

		outerChatHud.setExtent(%outerChatLenX,%outerChatLenY);
		chatScrollHud.setExtent(%chatScrollLenX,%chatScrollLenY);

		%totalLines = HudMessageVector.getNumLines();
		%posLines = $uberPref::chatHudLines[%length];
		%linesOver = ( %totalLines - %posLines );

		ChatPageDown.setPosition(firstWord(outerChatHud.extent) - 20,%chatScrollLenY - 6 );

		if( ( %linesOver > 0 ) && !%sizeIncrease ) {

			%posAdjust = %linesOver * ChatHud.profile.fontSize + 3;
			ChatHud.setPosition(0, -1 * %posAdjust);
		}
		else if(%sizeIncrease && (%linesOver > 0 )) {
			%curPos = getWord( ChatHud.position, 1 );
			%lines = $uberPref::chatHudLines[%length] -
					 $uberPref::chatHudLines[%length-1];

			%newY = %curPos + ( %lines * ChatHud.profile.fontSize );
			ChatHud.setPosition(0,%newY);
		}
		else if( %linesOver <= 0 ) ChatHud.position = "0 0";

		if ($uberPref::chatSizesUp) {

			outerChatHud.setPosition(firstWord(outerChatHud.position), 9);

			%tempY = getWord(outerChatHud.position, 1) - 7 ;
			%vTempY = %tempY - 10;
		}
		else {

			outerChatHud.setPosition(firstWord(outerChatHud.position),0);
			// adjust votehud to be just beneath chathud
			%tempY = getWord(outerChatHud.position, 1) + getWord(outerChatHud.extent, 1) + 2;
			%vTempY = %tempY + 10;
		}

		%mainVoteX = firstWord(mainVoteHud.position);
		%vCommX = firstWord(voiceCommHud.position);

		mainVoteHud.setPosition(%mainVoteX, %vTempY);
		voiceCommHud.setPosition(%vCommX, %vTempY);

		ChatHud.getGroup().setExtent(
			firstWord(ChatHud.extent) + firstWord(ChatHud.position),
			getWord(ChatHud.extent,1) + getWord(ChatHud.position,1)
		);

		%obj = OuterChatHud.getGroup();

		if ($uberPref::chatSizesUp) {
			//%obj.extent =
			//	(firstWord(outerChatHud.position) + firstWord(outerChatHud.extent)) SPC
			//	(getWord(outerChatHud.position,1) + getWord(outerChatHud.extent,1));
			%obj.setExtent(
				firstWord(outerChatHud.position) + firstWord(outerChatHud.extent),
				getWord(outerChatHud.position,1) + getWord(outerChatHud.extent,1)
			);

			%height -= getWord(OuterChatHud.extent,1);
			//%obj.position = (firstWord(%obj.position) SPC (getWord(%obj.position,1) + %height));
			%obj.setPosition(firstWord(%obj.position),getWord(%obj.position,1) + %height);
		}
		else {
			//%obj.extent =
			//	(firstWord(outerChatHud.position) + firstWord(outerChatHud.extent)) SPC
			//	(getWord(mainVoteHud.position,1) + getWord(mainVoteHud.extent,1));
			%obj.setExtent(
				firstWord(outerChatHud.position) + firstWord(outerChatHud.extent),
				getWord(mainVoteHud.position,1) + getWord(mainVoteHud.extent,1)
			);
		}
	}

	//function MessageHud::open(%this) {

	//	parent::open(%this);

	//	%x = getWord(outerChatHud.position, 0) + getWord(ChatHud.position, 0);
	//	messageHud_Frame.position = %x SPC getWord(messageHud_Frame.position,1);
	//}

	function MainChatHud::onWake(%this) {

		%this.setChatHudLength($uberPref::chatHudLength);
	}

	function MainChatHud::nextChatHudLen(%this) {

		$uberPref::chatHudLength++;

		if($uberPref::chatHudLength > $uberPref::maxHudLength) {
			$uberPref::chatHudLength = 1;
			%sizeIncrease = false;
			ChatPageDown.position = ( firstWord( outerChatHud.extent ) - 20 ) @ " 50";
		}
		else %sizeIncrease = true;

		%this.setChatHudLength($uberPref::chatHudLength,%sizeIncrease);

		adjustVoteHud();
	}

	function PlayGui::onWake(%this)	{

		parent::onWake(%this);
		uberChat.setWidth();
	}

	function ClientCmdDisplayHuds()	{

		parent::ClientCmdDisplayHuds();
		uberChat.setWidth();
	}

	function LoadingGui::onWake(%this) {

		parent::onWake();
		uberChat.setXparent();
	}

	function ScriptBrowserGui::onWake(%this) {

		parent::onWake();
		UberChatGui.onWake();
	}
};

function uberChat::activate(%this) {

	activatePackage(uberChatWrap);

	addMessageCallBack('MsgClientReady', "uberCheckGameType");

	uberChat.loadPrefs();
}

function uberChat::deactivate() {

	deactivatePackage(uberChatWrap);
}

function uberChat::selectFont(%this) {

	PJSelectFont("$uberPref::chatFont", "$uberPref::chatFontSize", "UberChat.setFont();");
}

function uberChat::setFont(%this) {

	%this.setUpGUI();
}

function uberChat::setUpGUI(%this) {

	uberChat.createProfile();

	if (!isObject(TestMessageVector)) new MessageVector(TestMessageVector);

	TestTextHud.detach();
	TestTextHud.attach(TestMessageVector);

	TestMessageVector.pushBackLine(" Your \c3Ally\c0 killed your \c5Enemy\c0.");
	TestMessageVector.pushBackLine(" \c2This is a common Message.");
	TestMessageVector.pushBackLine(" \c1This is a server status message.");
	TestMessageVector.pushBackLine(" \c3Team Chat.");
	TestMessageVector.pushBackLine(" \c4Global Chat.");
}

function uberChat::createProfile(%this) {

	if (isObject(TestTextHud)) TestTextHud.profile = "GuiChatHudProfile";
	if (isObject(chatHud)) chatHud.profile = "GuiChatHudProfile";

	if (isObject(uberChatHudProfile)) uberChatHudProfile.delete();

	new GuiControlProfile ("uberChatHudProfile") {
	   //fontType = ($uberPref::bold ? $ShellBoldFont : $ShellFont);
	   fontType = $uberPref::chatFont;
	   fontSize = $uberPref::chatFontSize;
	   fontColor     = $uberPref::fontColor[0];
	   fontColors[1] = $uberPref::fontColor[1];
	   fontColors[2] = $uberPref::fontColor[2];
	   fontColors[3] = $uberPref::fontColor[3];
	   fontColors[4] = $uberPref::fontColor[4];
	   fontColors[5] = $uberPref::fontColor[5];

	   autoSizeWidth = true;
	   autoSizeHeight = true;
	};

	if (isObject(TestTextHud)) TestTextHud.profile = "uberChatHudProfile";
	if (isObject(chatHud)) chatHud.profile = "uberChatHudProfile";
}

function uberChat::setWidth(%this) {

	%content = Canvas.getContent();
	if(isObject(%content) && (%content.getName() $= "PlayGui")) {

		%w = mFloor($uberPref::width * getWord($pref::Video::resolution,0) / 100);

		%passPct = (firstWord(passHash.position) - 1)/firstWord(mainVoteHud.extent);
		mainVoteHud.extent = tuple(%w, 5);
		voteHud.extent = tuple(%w - 12,3);
		passHash.position = tuple((firstWord(voteHud.extent) * %passPct) + 1, -1);
		OuterChatHud.extent = tuple(%w, getWord(OuterChatHud.extent,1));
		OuterChatHud.getGroup().extent =
			tuple(
				getWord(OuterChatHud.extent,0) + getWord(OuterChatHud.position,0),
				getWord(OuterChatHud.extent,1) + getWord(OuterChatHud.position,1)
			);
		chatPageDown.position = tuple(%w-6, getWord(chatPageDown.position,1));
		ChatScrollHud.extent = tuple(%w-4, getWord(ChatScrollHud.extent,1));
		ChatHud.extent = tuple(%w-4, getWord(ChatHud.extent,1));
		ChatHud.getGroup().extent = ChatHud.extent;

		chatHud.detach();
		chatHud.attach(HudMessageVector);
	}
}

function uberChat::setXparent(%this) {

	outerChatHud.profile =
		$uberPref::XparentChatHud ? "GuiConsoleProfile" : "GuiChatBackProfile";
}

function uberChat::setColors(%this, %idx, %color) {

	$uberPref::fontColor[%idx] = %color;

	//if (%idx == 0) uberChatHudProfile.fontColor = %color;
	//else uberChatHudProfile.fontColors[%idx] = %color;
}

function uberChat::setGameDefaults(%this) {

	$uberPref::fontColor[0] = GuiChatHudProfile.fontColor;
	$uberPref::fontColor[1] = GuiChatHudProfile.fontColors[1];
	$uberPref::fontColor[2] = GuiChatHudProfile.fontColors[2];
	$uberPref::fontColor[3] = GuiChatHudProfile.fontColors[3];
	$uberPref::fontColor[4] = GuiChatHudProfile.fontColors[4];
	$uberPref::fontColor[5] = GuiChatHudProfile.fontColors[5];

	$uberPref::chatFontSize = $ShellFontSize;

	$uberPref::chatHudLines[1] = 4;
	$uberPref::chatHudLines[2] = 8;
	$uberPref::chatHudLines[3] = 12;
	$uberPref::maxHudLength = 3;
	$uberPref::chatHudLength = 1;

	ChatWidth.setValue(252 * 100 / getWord($pref::Video::resolution,0));

	//Bold.setValue(false);
	Xparent.setValue(false);
	ColorKills.setValue(false);
	StripKeys.setValue(false);
	StripColor.setValue(false);
}

function uberChat::setUberDefaults(%this) {

	$uberPref::fontColor[0] = "220 220 220";
	$uberPref::fontColor[1] = "254 235 105";
	$uberPref::fontColor[2] = "219 200 128";
	$uberPref::fontColor[3] = "77 253 95";
	$uberPref::fontColor[4] = "40 231 240";
	$uberPref::fontColor[5] = "255 80 90";

	$uberPref::chatFontSize = $ShellFontSize;

	$uberPref::chatHudLines[1] = 4;
	$uberPref::chatHudLines[2] = 8;
	$uberPref::chatHudLines[3] = 12;
	$uberPref::maxHudLength = 3;
	$uberPref::chatHudLength = 1;

	ChatWidth.setValue(70);

	//Bold.setValue(true);
	Xparent.setValue(true);
	ColorKills.setValue(true);
	StripKeys.setValue(true);
	StripColor.setValue(true);
}

function uberChat::savePrefs(%this) {

	export("$uberPref::*", "prefs/uberPrefs.cs", false);
}

function UberChatGui::reDraw(%this) {

	uberChatGui.setWidth();
	uberChatGui.setPane(UberChatGui.tabIndex);
	uberChatGui.setColors(1);
}

function uberChat::resetPrefs(%this,%game) {

	if (%game)
		uberChat.setGameDefaults();
	else
		uberChat.setUberDefaults();

 	UberChatGui.fillSizes();
 	uberChat.createProfile();
 	UberChatGui.reDraw();
}

function uberChat::loadPrefs(%this, %force) {

	if (!$uberPref::loaded || %force) {
		exec("prefs/uberPrefs.cs");
		$uberPref::loaded = 1;
	}

	if ($uberPref::chatFont $= "") $uberPref::chatFont = $ShellFont;
	if ($uberPref::chatFontSize $= "") $uberPref::chatFontSize = $ShellFontSize;

	if ($uberPref::fontColor[0] $= "") $uberPref::fontColor[0] = "220 220 220";
	if ($uberPref::fontColor[1] $= "") $uberPref::fontColor[1] = "254 235 105";
	if ($uberPref::fontColor[2] $= "") $uberPref::fontColor[2] = "219 200 128";
	if ($uberPref::fontColor[3] $= "") $uberPref::fontColor[3] = "77 253 95";
	if ($uberPref::fontColor[4] $= "") $uberPref::fontColor[4] = "40 231 240";
	if ($uberPref::fontColor[5] $= "") $uberPref::fontColor[5] = "255 80 90";

	if ($uberPref::chatFontSize $= "") $uberPref::chatFontSize = $ShellFontSize;

	if ($uberPref::chatHudLines[1] $= "") $uberPref::chatHudLines[1] = 4;
	if ($uberPref::chatHudLines[2] $= "") $uberPref::chatHudLines[2] = 8;
	if ($uberPref::chatHudLines[3] $= "") $uberPref::chatHudLines[3] = 12;

	if($uberPref::maxHudLength $= "") $uberPref::maxHudLength = 3;
	if ($uberPref::chatHudLength $= "") $uberPref::chatHudLength = 1;

	if ($uberPref::width $= "") $uberPref::width = 70;
	if ($uberPref::XparentChatHud $= "") $uberPref::XparentChatHud = true;
	if ($uberPref::colorKills $= "") $uberPref::colorKills = true;
	if ($uberPref::muteChatKeys $= "") $uberPref::muteChatKeys = true;
	if ($uberPref::stripChatColor $= "") $uberPref::stripChatColor = true;

	ChatWidth.setValue($uberPref::width);

	UberChatGui.fillSizes();

	Xparent.setValue($uberPref::XparentChatHud);
	ColorKills.setValue($uberPref::colorKills );
	StripKeys.setValue($uberPref::muteChatKeys);
	StripColor.setValue($uberPref::stripChatColor);

 	uberChat.createProfile();
 	UberChatGui.reDraw();
}

function uberCheckGameType(%msgType, %msgString, %gameType) {

	//echo(%gameType);
	switch$ (%gameType) {

		case DndGame:
			uberChat.colorKills = false;

		case BountyGame:
			uberChat.colorKills = false;

		case CnHGame:
			uberChat.colorKills = true;

		case CTFGame:
			uberChat.colorKills = true;

		case DMGame:
			uberChat.colorKills = false;

		case DnDGame:
			uberChat.colorKills = true;

		case HuntersGame:
			uberChat.colorKills = false;

		case RabbitGame:
			uberChat.colorKills = true;

		case SiegeGame:
			uberChat.colorKills = true;

		//Odd, I seem to need this on some servers...
		case SiegeGameGame:
			uberChat.colorKills = true;

		case TeamHuntersGame:
			uberChat.colorKills = true;

		case ArenaGame:
			uberChat.colorKills = true;

		case TR2Game:
			uberChat.colorKills = true;

		case SinglePlayerGame:
			uberChat.colorKills = false;
	}
}

//=GUI Object Methods==================================================

function UberChatGui::onWake(%this) {

	Tab3.setValue(true);
 	UberChatGui.reDraw();}

function UberChatGui::setPane(%this, %idx) {

	if (strlen(%this.tabIndex)) {
		%lastTab = "Tab" @ %this.tabIndex;
		%lastTab.setValue(false);
	}
	%thisTab = "Tab" @ %idx;
	%thisTab.setValue(true);

	%this.tabIndex = %idx;

	UC_Red.setValue(getWord($uberPref::fontColor[%idx],0));
	UC_Green.setValue(getWord($uberPref::fontColor[%idx],1));
	UC_Blue.setValue(getWord($uberPref::fontColor[%idx],2));
}

function UberChatGui::setColors(%this, %done) {

	%R = mCeil(UC_Red.value);
	%G = mCeil(UC_Green.value);
	%B = mCeil(UC_Blue.value);

	lblRed.setValue("RED ("   @ %R @ ")");
	lblGrn.setValue("GREEN (" @ %G @ ")");
	lblBlu.setValue("BLUE ("  @ %B @ ")");

	if (%done) {
		uberChat.setColors(%this.tabIndex,triple(%R,%G,%B) @ " 255");
		uberChat.setUpGUI();
	}
}

function UberChatGui::setWidth(%this) {

	$uberPref::width = mFloor(ChatWidth.value);
	lblWdth.setValue("Chat Hud Width (" @ $uberPref::width @ "%)");
}

function UberChatGui::insertSize(%this) {

	if ($UberChatSize::newValue <= 0) {
		UC_newSize.setValue("");
		return;
	}

	uberChatSize::pushSize($UberChatSize::newValue);
	UC_newSize.setValue("");
	%this.fillSizes();
}

function UberChatGui::deleteSize() {

	if ($uberPref::maxHudLength > 1) {
		%idx = UC_Sizes.getSelectedId();
		if (%idx >=1 && %idx <= $uberPref::maxHudLength) {
			uberChatSize::popSize(%idx);
			UC_Sizes.deleteRow(%idx);
		}
	}
}

function UberChatGui::fillSizes() {

	UC_Sizes.clear();
	for(%i=1;%i <= $uberPref::maxHudLength;%i++) {
		UC_Sizes.addRow(%i,$uberPref::chatHudLines[%i]);
	}
}

//=Utility Container===========================================================
// A stripped down version of Vector.cs

function uberChatSize::pushSize(%size) {

	$uberPref::maxHudLength++;
	$uberPref::chatHudLines[$uberPref::maxHudLength] = %size;
	uberChatSize::sortSizes();
	UberChatGui.fillSizes();
}

function uberChatSize::popSize(%idx) {

	if (%idx <= $uberPref::maxHudLength && %idx > 0) {
		for (%i=%idx;%i<$uberPref::maxHudLength;%i++) {
			$uberPref::chatHudLines[%i] = $uberPref::chatHudLines[%i+1];
		}
		$uberPref::chatHudLines[%i] = "";
	}
	$uberPref::maxHudLength--;
	UC_Sizes.removeRow(%idx--);
}

function uberChatSize::sortSizes() {
	// Insertion sort - should be good for 10 or so entries

	%begin = 1;
	%end = $uberPref::maxHudLength;

	for (%i = (%begin+1); %i <= %end; %i++) {
		%temp = $uberPref::chatHudLines[%i];
		for (%j = (%i-1); %j >= %begin; %j--) {
			if ($uberPref::chatHudLines[%j] > %temp) {
				$uberPref::chatHudLines[%j+1] = $uberPref::chatHudLines[%j];
			}
			else {
				break;
			}
		}
		$uberPref::chatHudLines[%j+1] = %temp;
	}
}

//=GUI ========================================================================

if(!isObject(UberChatGui)) {

	new GuiControl(UberChatGui) {
		profile = "GuiTextObjGreenCenterProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "0 9";
		extent = "400 334";
		minExtent = "400 320";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";

		tabIndex = "3";
		guiSetup = "1";

		new ShellToggleButton(Xparent) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "7 28";
			extent = "85 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$uberPref::XparentChatHud";
			command = "uberChat.setXparent();";
			helpTag = "0";
			text = "Transparent";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "335 297";
			extent = "61 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "uberChat.savePrefs();";
			helpTag = "0";
			text = "Save";
			simpleStyle = "0";
		};
		new ShellFieldCtrl() {
			profile = "ShellFieldProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 65";
			extent = "117 137";
			minExtent = "16 18";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new ShellScrollCtrl() {
				profile = "NewScrollCtrlProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "17 40";
				extent = "86 98";
				minExtent = "24 24";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				willFirstRespond = "1";
				hScrollBar = "alwaysOff";
				vScrollBar = "dynamic";
				constantThumbHeight = "0";
				defaultLineHeight = "15";
				childMargin = "0 0";
				fieldBase = "gui/shll_field";

				new GuiScrollContentCtrl() {
					profile = "GuiDefaultProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "4 4";
					extent = "78 90";
					minExtent = "8 8";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";

					new ShellTextList(UC_Sizes) {
						profile = "ShellTextArrayProfile";
						horizSizing = "right";
						vertSizing = "bottom";
						position = "0 0";
						extent = "78 54";
						minExtent = "8 8";
						visible = "1";
						hideCursor = "0";
						bypassHideCursor = "0";
						helpTag = "0";
						enumerate = "0";
						resizeCell = "1";
						columns = "0";
						fitParentWidth = "1";
						clipColumnText = "0";
					};
				};
			};
			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "-5 13";
				extent = "55 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "UberChatGui.insertSize();";
				helpTag = "0";
				text = "Add";
				simpleStyle = "0";
			};
			new ShellBitmapButton() {
				profile = "ShellButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "65 13";
				extent = "55 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "UberChatGui.deleteSize();";
				helpTag = "0";
				text = "Delete";
				simpleStyle = "0";
			};
			new ShellTextEditCtrl(UC_newSize) {
				profile = "NewTextEditProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "31 13";
				extent = "50 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$UberChatSize::newValue";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "2";
				historySize = "0";
				password = "0";
				IRCName = "0";
				tabComplete = "0";
				deniedSound = "InputDeniedSound";
				glowOffset = "9 9";
			};
			new GuiTextCtrl() {
				profile = "GuiHelpTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "13 1";
				extent = "90 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Chat Hud Sizes";
				longTextBuffer = "0";
				maxLength = "255";
			};
		};
		new ShellTabButton(Tab3) {
			profile = "ShellTabProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "128 58";
			extent = "140 38";
			minExtent = "48 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "UberChatGui.setPane(3);";
			helpTag = "0";
			text = "Friendly Names";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellTabButton(Tab5) {
			profile = "ShellTabProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "128 81";
			extent = "140 38";
			minExtent = "48 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "UberChatGui.setPane(5);";
			helpTag = "0";
			text = "Enemy Names";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellTabButton(Tab4) {
			profile = "ShellTabProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "128 104";
			extent = "140 38";
			minExtent = "48 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "UberChatGui.setPane(4);";
			helpTag = "0";
			text = "Global Text";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellTabButton(Tab2) {
			profile = "ShellTabProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "128 127";
			extent = "140 38";
			minExtent = "48 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "UberChatGui.setPane(2);";
			helpTag = "0";
			text = "Standard Notices";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellTabButton(Tab1) {
			profile = "ShellTabProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "128 150";
			extent = "140 38";
			minExtent = "48 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "UberChatGui.setPane(1);";
			helpTag = "0";
			text = "Special Notices";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton(StripColor) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "92 6";
			extent = "104 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$uberPref::stripChatColor";
			helpTag = "0";
			text = "Strip Chat Colors";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton(colorKills) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "7 6";
			extent = "84 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$uberPref::colorKills";
			helpTag = "0";
			text = "Color Kills";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton(ExpandUp) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "92 28";
			extent = "104 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$uberPref::chatSizesUp";
			helpTag = "0";
			text = "Chat Expands Up";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton(UndockChat) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "196 28";
			extent = "100 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$uberPref::chatUndockInput";
			helpTag = "0";
			text = "Free Input Box";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellFieldCtrl() {
			profile = "ShellFieldProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 208";
			extent = "378 83";
			minExtent = "16 18";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new GuiMessageVectorCtrl(TestTextHud) {
				profile = "uberChatHudProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "365 16";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				lineSpacing = "0";
				lineContinuedIndex = "10";
				matchColor = "0 0 255 255";
				maxColorIndex = "9";
			};
		};
		new ShellTabButton(Tab0) {
			profile = "ShellTabProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "128 173";
			extent = "139 38";
			minExtent = "48 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "UberChatGui.setPane(0);";
			helpTag = "0";
			text = "Plain Text";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellFieldCtrl() {
			profile = "ShellFieldProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "11 305";
			extent = "126 22";
			minExtent = "16 18";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new ShellSliderCtrl(ChatWidth) {
				profile = "ShellSliderProfile";
				horizSizing = "center";
				vertSizing = "center";
				position = "4 -1";
				extent = "118 24";
				minExtent = "12 24";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "value";
				altCommand = "uberChatGui.setWidth();";
				helpTag = "0";
				range = "0.000000 100.000000";
				ticks = "1000";
				value = "70";
				usePlusMinus = "0";

				format = "%1.0f";
			};
		};
		new GuiTextCtrl(lblWdth) {
			profile = "DeathMsgTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "13 292";
			extent = "134 16";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Chat Hud Width";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton(StripKeys) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "196 6";
			extent = "100 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$uberPref::muteChatKeys";
			helpTag = "0";
			text = "Strip Chat Keys";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "291 297";
			extent = "60 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "uberChat.loadPrefs(1);";
			helpTag = "0";
			text = "Load";
			simpleStyle = "0";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "211 297";
			extent = "90 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "uberChat.resetPrefs(0);";
			helpTag = "0";
			text = "Script Defaults";
			simpleStyle = "0";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "136 297";
			extent = "90 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "uberChat.resetPrefs(1);";
			helpTag = "0";
			text = "Game Defaults";
			simpleStyle = "0";
		};
		new ShellFieldCtrl() {
			profile = "ShellFieldProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "268 62";
			extent = "119 143";
			minExtent = "16 18";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new GuiTextCtrl(lblGrn) {
				profile = "TaskHudTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "13 52";
				extent = "60 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "GREEN";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new GuiTextCtrl(lblRed) {
				profile = "TaskHudTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "13 8";
				extent = "41 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "RED";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new ShellFieldCtrl() {
				profile = "ShellFieldProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "12 22";
				extent = "96 27";
				minExtent = "16 18";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";

				new ShellSliderCtrl(UC_Red) {
					profile = "ShellSliderProfile";
					horizSizing = "center";
					vertSizing = "center";
					position = "5 1";
					extent = "86 24";
					minExtent = "12 24";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "value";
					command = "UberChatGui.setColors(1);";
					altCommand = "UberChatGui.setColors(0);";
					helpTag = "0";
					range = "0.000000 255.000000";
					ticks = "1000";
					value = "77";
					usePlusMinus = "0";

					format = "%1.0f";
				};
			};
			new ShellFieldCtrl() {
				profile = "ShellFieldProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "12 66";
				extent = "96 27";
				minExtent = "16 18";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";

				new ShellSliderCtrl(UC_Green) {
					profile = "ShellSliderProfile";
					horizSizing = "center";
					vertSizing = "center";
					position = "5 1";
					extent = "86 24";
					minExtent = "12 24";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "value";
					command = "UberChatGui.setColors(1);";
					altCommand = "UberChatGui.setColors(0);";
					helpTag = "0";
					range = "0.000000 255.000000";
					ticks = "1000";
					value = "253";
					usePlusMinus = "0";

					format = "%1.0f";
				};
			};
			new ShellFieldCtrl() {
				profile = "ShellFieldProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "12 108";
				extent = "96 27";
				minExtent = "16 18";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";

				new ShellSliderCtrl(UC_Blue) {
					profile = "ShellSliderProfile";
					horizSizing = "center";
					vertSizing = "center";
					position = "5 1";
					extent = "86 24";
					minExtent = "12 24";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					variable = "value";
					command = "UberChatGui.setColors(1);";
					altCommand = "UberChatGui.setColors(0);";
					helpTag = "0";
					range = "0.000000 255.000000";
					ticks = "1000";
					value = "95";
					usePlusMinus = "0";

					format = "%1.0f";
				};
			};
			new GuiTextCtrl(lblBlu) {
				profile = "TaskHudTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "13 94";
				extent = "46 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "BLUE";
				longTextBuffer = "0";
				maxLength = "255";
			};
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "299 11";
			extent = "83 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "uberChat.selectFont();";
			helpTag = "0";
			text = "Select Font";
			simpleStyle = "0";
		};
//		new ShellToggleButton() {
//			profile = "ShellRadioProfile";
//			horizSizing = "right";
//			vertSizing = "bottom";
//			position = "297 28";
//			extent = "85 30";
//			minExtent = "26 27";
//			visible = "1";
//			hideCursor = "0";
//			bypassHideCursor = "0";
//			variable = "$uberPref::muteFags";
//			helpTag = "0";
//			text = "Voice Block";
//			longTextBuffer = "0";
//			maxLength = "255";
//		};
	};}

uberChat.activate();