// #autoload
// #name = DioCompareTeams
// #version = 1.1
// #date = 3/18/2002 11:29PM
// #status = release
// #author = |Rx|Diogenes
// #warrior = Diogenes
// #email = diogenes@tribalpharmacy.com
// #web = http://dioscripts.tribes-universe.com
// #description = Compare vital stats of teams.
// #category = DioScripts
// #include = support/player_support.cs

if(!isObject(DioCompareTeams))
{
	new ScriptObject(DioCompareTeams)
	{
		class = DioCompareTeams;
	};
}

package DioCompareTeams {
	
function DioCompareTeams(%val){
	if (DioCompareTeams.schedule != 0) 
		cancel(DioCompareTeams.schedule);
		
	commandToServer('getScores');
	DioCompareTeams.schedule = schedule(2000, 0, DioCompareTeamsResponse);
	%message = "DioCompareTeams: Getting Data";
	defaultmessagecallback('', %message);
}

function DioCompareTeamsResponse(){
	%team1count = 0;
	%team2count = 0;
	%team1ping = 0;
	%team2ping = 0;
	%team1ping = 0;
	%team2ping = 0;	
	%team1score = 0;
	%team2score = 0;	
	
	while(PlayerListGroup.getObject(%i) != -1){
		// Team One Stuff
		if(PlayerList.getTeamByIndex(%i) == 1 ){
			%team1ping = %team1ping + getword(PlayerList.getNetInfoByIndex(%i),0);
			%team1pl = %team1pl + getword(PlayerList.getNetInfoByIndex(%i),1);
			%team1score = %team1score + PlayerList.getScoreByIndex(%i);
			%team1count++;
		}
		
		// Team Two Stuff
		if(PlayerList.getTeamByIndex(%i) == 2 ){
			%team2ping = %team2ping + getword(PlayerList.getNetInfoByIndex(%i),0);
			%team2pl = %team2pl + getword(PlayerList.getNetInfoByIndex(%i),1);
			%team2score = %team2score + PlayerList.getScoreByIndex(%i);
			%team2count++;
		}
		%i++;
	} 
	
	
	%team1aveping = mfloor(%team1ping / %team1count);
	%team1avepl = mfloor(%team1pl / %team1count);
	%team1avescore = mfloor(%team1score / %team1count);

	
	%team2aveping = mfloor(%team2ping / %team2count);
	%team2avepl = mfloor(%team2pl / %team1count);	
	%team2avescore = mfloor(%team2score / %team2count);
	
	%message= "\c3  Team 1 (\c4"@ %team1count @"\c3) - Average Ping: \c4" @ %team1aveping @ "\c3 (\c2"@ %team1ping @"\c3) Average PL:\c4 " @ %team1avepl @ "\c3 (\c2"@ %team1pl @"\c3) Average Score: \c4" @ %team1avescore @" \n";
	%message= %message @ "\c3Team 2 (\c4"@ %team2count @"\c3) - Average Ping: \c4" @ %team2aveping @ "\c3 (\c2"@ %team2ping @"\c3) Average PL: \c4" @ %team2avepl @ "\c3 (\c2"@ %team2pl @"\c3) Average Score: \c4" @ %team2avescore;
	defaultmessagecallback('', %message);

}

function OptionsDlg::onWake( %this ) {//Classic key binding
	if(!$DioCompareTeamsBind) {
		$RemapName[$RemapCount]="DioCompareTeams";
		$RemapCmd[$RemapCount]="DioCompareTeams";
		$RemapCount++;
		$DioCompareTeamsBind = true;
	}
	parent::onWake( %this );
}

};

activatepackage(DioCompareTeams);