if (!isObject(TimInv))
{
	new scriptObject(TimInv)
	{
		// constants - dont touch theese
		class = TimInv;
		gui = "TimInvGui";
		grenade = "TimInvGrenadeGui";
		mine = "TimInvHudMineGui";
		healthkit = "TimInvHealthKitGui";
		beacon = "TimInvBeaconGui";
		// user config - feel free to edit theese
		transparent = false; // make the hud transparent?
		font = "Verdana Bold"; // the text font
		fontSize = "12"; // the text size
		color = "F0F0F0"; // the text color
		// user config end - don't touch anything below here.
	};
}

function TimInv::HandleInv(%this, %slot, %amount)
{
	%text = "<just:center><font:" @ %this.font @ ":" @ %this.fontSize @ "><color:" @ %this.color @ ">" @ %amount;
	switch(%slot)
	{
		case 0:
			%this.grenade.setText(%text);
		case 1:
			%this.mine.setText(%text);
		case 2:
			%this.beacon.setText(%text);
		case 3:
			%this.healthkit.setText(%text);
		default:
			error("inventory slot" SPC %slot SPC "does not exist");
	}
}

function TimInv::Position(%this)
{
	if(!isObject(Timhud))
		return;

	%this.gui.resize(getWord(TimHud.gui.position, 0) + getWord(TimHud.gui.extent, 0) + 5, getWord(TimHud.gui.position, 1), getWord(%this.gui.extent, 0), getWord(%this.gui.extent, 1));
	%this.positioned = true;
}

package TimInv
{
	function DispatchLaunchMode()
	{
		parent::DispatchLaunchMode();
		TimInv.Create();		
	}
	
	function clientCmdSetInventoryHudAmount(%slot, %amount)
	{
		parent::clientCmdSetInventoryHudAmount(%slot, %amount);
		TimInv.HandleInv(%slot, %amount);		
	}
	
	function playGui::onWake(%this)
	{
		parent::onWake(%this);
		if(!TimInv.positioned) TimInv.schedule(1000, Position);
	}
	
	function loadingGui::onWake(%this)
	{
		parent::onWake(%this);
		if(isObject(HM) && isObject(HudMover)) hudmover::addhud(TimInv.gui, "TimstaInvHud");
	}
	
	function clientCmdTogglePlayHuds(%val)
	{
		parent::clientCmdTogglePlayHuds(%val);
		TimInv.gui.setVisible(%val);
	}
	
	function ClientCmdSetHudMode(%mode, %type, %node)
	{
		// remove the hud if we're in a vehicle
		if((getWord(%mode, 1) $= "Standard") || (getWord(%mode, 1) $= "Observer"))
			TimInv.gui.setVisible(true);
		else
			TimInv.gui.setVisible(false);
		
		parent::ClientCmdSetHudMode(%mode, %type, %node);
	}
};
activatePackage(TimInv);

function TimInv::Create(%this)
{
	if(isObject(%this.gui))
		%this.Destroy();
		
	if(%this.transparent)
		%profile = "GuiConsoleProfile";
	else
		%profile = "";
	
	new GuiControl(%this.gui) 
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "86 50";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		
		new ShellFieldCtrl() 
		{
			profile = %profile;
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "86 50";
			minExtent = "16 18";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
	
			new GuiBitmapCtrl() 
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "3 4";
				extent = "20 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				bitmap = "TimInv/grenade";
				wrap = "0";
			};
			new GuiBitmapCtrl() 
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "23 4";
				extent = "20 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				bitmap = "TimInv/mine";
				wrap = "0";
			};
			new GuiBitmapCtrl() 
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "43 4";
				extent = "20 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				bitmap = "TimInv/healthkit";
				wrap = "0";
			};
			new GuiBitmapCtrl() 
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "63 4";
				extent = "20 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				bitmap = "TimInv/beacon";
				wrap = "0";
			};
			new GuiMLTextCtrl(%this.grenade) 
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "3 29";
				extent = "20 14";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				lineSpacing = "2";
				allowColorChars = "0";
				maxChars = "-1";
				deniedSound = "InputDeniedSound";
			};
			new GuiMLTextCtrl(%this.mine) 
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "23 29";
				extent = "20 14";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				lineSpacing = "2";
				allowColorChars = "0";
				maxChars = "-1";
				deniedSound = "InputDeniedSound";				
			};
			new GuiMLTextCtrl(%this.healthkit) 
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "43 29";
				extent = "20 14";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				lineSpacing = "2";
				allowColorChars = "0";
				maxChars = "-1";
				deniedSound = "InputDeniedSound";
			};
			new GuiMLTextCtrl(%this.beacon) 
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "63 29";
				extent = "20 14";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				lineSpacing = "2";
				allowColorChars = "0";
				maxChars = "-1";
				deniedSound = "InputDeniedSound";
			};
		};
	};
	playGui.add(%this.gui);	
	%this.grenade.setText("<just:center><font:" @ %this.font @ ":" @ %this.fontSize @ "><color:" @ %this.color @ ">0");
	%this.mine.setText("<just:center><font:" @ %this.font @ ":" @ %this.fontSize @ "><color:" @ %this.color @ ">0");
	%this.healthkit.setText("<just:center><font:" @ %this.font @ ":" @ %this.fontSize @ "><color:" @ %this.color @ ">0");
	%this.beacon.setText("<just:center><font:" @ %this.font @ ":" @ %this.fontSize @ "><color:" @ %this.color @ ">0");
	
	if(playGui.isMember(inventoryHud)) playGui.remove(inventoryhud);
}

function TimInv::Destroy(%this)
{
	playgui.remove(%this.gui);
	%this.gui.Delete();
}
