// #autoload
// #name = UberAmmo
// #version = 1.1.2
// #date = January 25, 2003
// #author = Paul Tousignant
// #warrior = UberGuy (FT)
// #email = uberguy@tribalwar.com
// #web = http://scripts.tribalwar.com/uberguy
// #web = http://scripts.tribes-universe.com/uberguy
// #description = Small individual HUDs showing ammo, number of mines, beacons, and grenades and iconic grenade type.
// #category = UberGuy's Scripts
// #status = Release
// #readme = scripts/UberGuy/UberAmmo.txt
// #config = UberAmmoGUI
// #include = support/events.cs
// #include = support/loadout.cs 0.0.8

$UA_typeImage["Grenade"] = "texticons/gren.png";
$UA_typeImage["Whiteout Grenade"] = "texticons/flash.png";
$UA_typeImage["Concussion Grenade"] = "texticons/conc.png";
$UA_typeImage["Flare Grenade"] = "texticons/flare.png";
$UA_typeImage["Deployable Camera"] = "texticons/camera.png";

function UA_grenCountHUD::setAmount(%this, %amount) {

	UA_grenCountHUD1.setText(%amount);
	UA_grenCountHUD2.setText(%amount);
	if (%amount == 0) UA_grenTypeHUD.setBitmap("texticons/blank.png");
}

function UA_mineCountHUD::setAmount(%this, %amount) {

	UA_mineCountHUD1.setText(%amount);
	UA_mineCountHUD2.setText(%amount);
}

function UA_beacCountHUD::setAmount(%this, %amount) {

	UA_beacCountHUD1.setText(%amount);
	UA_beacCountHUD2.setText(%amount);
}

function UA_ammoCountHUD::setAmount(%this, %amount) {

	UA_ammoCountHUD1.setText(%amount);
	UA_ammoCountHUD2.setText(%amount);
}
function UA_updateGrens() {

	UA_grenCountHUD.setAmount(loadout.getGrenadeAmmo());
}

function UA_updateGrenType() {

	%image = $UA_typeImage[loadout.getGrenadeType()];
	if (%image $= "") UA_grenTypeHUD.setBitmap("texticons/blank.png");
	else UA_grenTypeHUD.setBitmap(%image);
}

function UA_updateMines() {

	UA_mineCountHUD.setAmount(loadout.getMineAmmo());
}

function UA_updateBeacs() {

	UA_beacCountHUD.setAmount(loadout.getBeaconAmmo());
}

function UA_updateAll() {

	UA_grenCountHUD.setAmount(0);
	UA_grenTypeHUD.setBitmap("texticons/blank.png");
	UA_mineCountHUD.setAmount(0);
	UA_beacCountHUD.setAmount(0);
}
	
function UA_toggleHuds(%val) {

	UA_grenCountHUD.setVisible(%val);
	UA_mineCountHUD.setVisible(%val);
	UA_beacCountHUD.setVisible(%val);
	UA_ammoCountHUD.setVisible(%val);
	UA_grenTypeHUD.setVisible(%val);
}

function UberAmmoGUI::onWake(%this) {

	// prevent spam
}

package UberAmmoPkg {

	function ammoHud::setValue(%this, %val) {

		parent::setValue(%this, %val);
		UA_ammoCountHUD1.setValue(%val);
		UA_ammoCountHUD2.setValue(%val);
	}

	function ammoHud::setProfile(%this, %prof) {

		parent::setProfile(%prof);
		UA_ammoCountHUD2.setProfile(%prof);
	}
};

function UA_hideOnZoom(%val) {

	if ($ZoomOn) {
		if ($pref::UberAmmo::hideOnZoom) {
			UA_grenCountHUD.setVisible(false);
			UA_mineCountHUD.setVisible(false);
			UA_beacCountHUD.setVisible(false);
			UA_ammoCountHUD.setVisible(false);
			UA_grenTypeHUD.setVisible(false);
			if (isObject(uberKitIcon)) uberKitIcon.setVisible(false);
		}
	}
	else {
		UA_grenCountHUD.setVisible(true);
		UA_mineCountHUD.setVisible(true);
		UA_beacCountHUD.setVisible(true);
		UA_ammoCountHUD.setVisible(true);
		UA_grenTypeHUD.setVisible(true);
		if (isObject(uberKitIcon)) uberKitIcon.setVisible($uberPref::UK::showIcon);
	}
}

function UA_setupHuds() {

	if (!$UberAmmo::configured) {

		new GuiControlProfile("UA_grenCountHUDProfile") {
		   fontType = "Univers Condensed";
		   fontSize = 16;
		   fontColor = "130 255 130 120";
		   autoSizeWidth = false;
		   autoSizeHeight = true;
		};

		new GuiControlProfile("UA_mineCountHUDProfile") {
		   fontType = "Univers Condensed";
		   fontSize = 16;
		   fontColor = "255 255 130 120";
		   autoSizeWidth = false;
		   autoSizeHeight = true;
		};

		new GuiControlProfile("UA_beacCountHUDProfile") {
		   fontType = "Univers Condensed";
		   fontSize = 16;
		   fontColor = "130 130 255 120";
		   autoSizeWidth = false;
		   autoSizeHeight = true;
		};

		new GuiControlProfile("UA_backCountHUDProfile") {
		   fontType = "Univers Condensed";
		   fontSize = 16;
		   fontColor = "0 0 0 200";
		   autoSizeWidth = false;
		   autoSizeHeight = true;
		};


		new ShellFieldCtrl(UA_grenCountHUD) {
			profile = "GuiDefaultProfile" ;
			horizSizing = "right";
			vertSizing = "bottom";
			position = "5 165";
			extent = "31 21";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new GuiTextCtrl(UA_grenCountHUD1) {
				profile = "UA_backCountHUDProfile";
				horizSizing = "left";
				vertSizing = "top";
				position = "1 1";
				extent = "30 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				text = "0";
			};

			new GuiTextCtrl(UA_grenCountHUD2) {
				profile = "UA_grenCountHUDProfile";
				horizSizing = "left";
				vertSizing = "top";
				position = "0 0";
				extent = "30 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				text = "0";
			};
		};

		new ShellFieldCtrl(UA_mineCountHUD) {
			profile = "GuiDefaultProfile" ;
			horizSizing = "right";
			vertSizing = "bottom";
			position = "5 185";
			extent = "31 21";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new GuiTextCtrl(UA_mineCountHUD1) {
				profile = "UA_backCountHUDProfile";
				horizSizing = "left";
				vertSizing = "top";
				position = "1 1";
				extent = "30 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				text = "0";
			};

			new GuiTextCtrl(UA_mineCountHUD2) {
				profile = "UA_mineCountHUDProfile";
				horizSizing = "left";
				vertSizing = "top";
				position = "0 0";
				extent = "30 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				text = "0";
			};
		};

		new ShellFieldCtrl(UA_beacCountHUD) {
			profile = "GuiDefaultProfile" ;
			horizSizing = "right";
			vertSizing = "bottom";
			position = "5 205";
			extent = "31 21";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new GuiTextCtrl(UA_beacCountHUD1) {
				profile = "UA_backCountHUDProfile";
				horizSizing = "left";
				vertSizing = "top";
				position = "1 1";
				extent = "30 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				text = "0";
			};

			new GuiTextCtrl(UA_beacCountHUD2) {
				profile = "UA_beacCountHUDProfile";
				horizSizing = "left";
				vertSizing = "top";
				position = "0 0";
				extent = "30 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				text = "0";
			};
		};

		new ShellFieldCtrl(UA_ammoCountHUD) {
			profile = "GuiDefaultProfile" ;
			horizSizing = "right";
			vertSizing = "bottom";
			position = "5 225";
			extent = "31 21";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new GuiTextCtrl(UA_ammoCountHUD1) {
				profile = "UA_backCountHUDProfile";
				horizSizing = "left";
				vertSizing = "top";
				position = "1 1";
				extent = "30 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				text = "0";
			};

			new GuiTextCtrl(UA_ammoCountHUD2) {
				profile = "GuiAmmoHudProfile";
				horizSizing = "left";
				vertSizing = "top";
				position = "0 0";
				extent = "30 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				text = "0";
			};
		};

		new HudPulsingBitmap(UA_grenTypeHUD) {
			profile = "GuiButtonProfile";
			horizSizing = "bottom";
			vertSizing = "right";
			position = "15 167";
			extent = "13 13";
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			fillColor = "0.250000 0.250000 0.250000 0.00000";
			frameColor = "0.000000 1.000000 0.000000 0.000000";
			opacity = "0.45";
			bitmap = "texticons/gren.png";
			autoCenter = "0";
			autoResize = "0";
			flipVertical = "0";
			flipHorizontal = "0";
		};

		if (isObject(HM) && isObject(HudMover)) {
			hudmover::addhud(UA_grenCountHUD, "UberGrenade Count HUD");
			hudmover::addhud(UA_grenTypeHUD,  "UberGrenade Type Icon");
			hudmover::addhud(UA_beacCountHUD, "UberBeacon Count HUD");
			hudmover::addhud(UA_mineCountHUD, "UberMine Count HUD");
			hudmover::addhud(UA_ammoCountHUD, "UberAmmo Count HUD");
		}


		if ($pref::UberAmmo::grenHUD $= "") $pref::UberAmmo::grenHUD = true;
		if ($pref::UberAmmo::mineHUD $= "") $pref::UberAmmo::mineHUD = true;
		if ($pref::UberAmmo::beacHUD $= "") $pref::UberAmmo::beacHUD = true;
		if ($pref::UberAmmo::ammoHUD $= "") $pref::UberAmmo::ammoHUD = true;
		if ($pref::UberAmmo::typeHUD $= "") $pref::UberAmmo::typeHUD = true;

		if ($pref::UberAmmo::hideOnZoom $= "") $pref::UberAmmo::hideOnZoom = true;

		$UberAmmo::configured = true;
	}

	if ($pref::UberAmmo::grenHUD) playGui.add(UA_grenCountHUD);
	else if (playGui.isMember(UA_grenCountHUD)) playGui.remove(UA_grenCountHUD);

	if ($pref::UberAmmo::mineHUD) playGui.add(UA_mineCountHUD);
	else if (playGui.isMember(UA_mineCountHUD)) playGui.remove(UA_mineCountHUD);

	if ($pref::UberAmmo::beacHUD) playGui.add(UA_beacCountHUD);
	else if (playGui.isMember(UA_beacCountHUD)) playGui.remove(UA_beacCountHUD);

	if ($pref::UberAmmo::typeHUD) playGui.add(UA_grenTypeHUD);
	else if (playGui.isMember(UA_grenTypeHUD)) playGui.remove(UA_grenTypeHUD);

	if ($pref::UberAmmo::ammoHUD) {

		playGui.add(UA_ammoCountHUD);

		if (isObject(ammoHud.getGroup())) {
			$UberAmmo::ammoParent = ammoHud.getGroup();
			$UberAmmo::ammoParent.remove(ammoHud);
		}
	}
	else {

		if (playGui.isMember(UA_ammoCountHUD)) playGui.remove(UA_ammoCountHUD);

		if (isObject($UberAmmo::ammoParent)) $UberAmmo::ammoParent.add(ammoHud);
		$UberAmmo::ammoParent = "";
	}

	if ($pref::UberAmmo::hideInvHUD) {
		if (isObject(inventoryHud.getGroup())) {
			$UberAmmo::invoParent = inventoryHud.getGroup();
			$UberAmmo::invoParent.remove(inventoryHud);
		}
	}
	else {
		if (isObject($UberAmmo::invoParent)) $UberAmmo::invoParent.add(inventoryHud);
		$UberAmmo::invoParent = "";
	}
}

if (!isObject(UberAmmoGUI)) {

	new ShellFieldCtrl(UberAmmoGUI) {
		profile = "GuiDefaultProfile";
		horizSizing = "width";
		vertSizing = "height";
		position = "0 0";
		extent = "400 350";
		minExtent = "16 18";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
	};
}

while (UberAmmoGUI.getCount() > 0) {
	UberAmmoGUI.getObject(0).delete();
}

new ShellFieldCtrl(UberAmmoGUI2) {
	profile = "ShellFieldProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "35 31";
	extent = "330 288";
	minExtent = "16 18";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
		profile = "ShellPaneProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "4 15";
		extent = "320 268";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Uber\'s ExplosivesHUDs";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";

		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "92 125";
			extent = "135 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$pref::UberAmmo::beacHUD";
			helpTag = "0";
			text = "Show Beacon Ct. HUD";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "92 75";
			extent = "135 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$pref::UberAmmo::grenHUD";
			helpTag = "0";
			text = "Show Gren Count HUD";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "92 50";
			extent = "135 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$pref::UberAmmo::mineHUD";
			helpTag = "0";
			text = "Show Mine Count HUD";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "92 100";
			extent = "135 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$pref::UberAmmo::typeHUD";
			helpTag = "0";
			text = "Show Gren Type HUD";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "92 200";
			extent = "135 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$pref::UberAmmo::hideOnZoom";
			helpTag = "0";
			text = "Hide HUDs on Zoom";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "92 150";
			extent = "135 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$pref::UberAmmo::ammoHUD";
			helpTag = "0";
			text = "Show New Ammo HUD";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "92 175";
			extent = "135 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$pref::UberAmmo::hideInvHUD";
			helpTag = "0";
			text = "Hide InventoryHUD";
			longTextBuffer = "0";
			maxLength = "255";
		};
	};
};

UberAmmoGUI.add(UberAmmoGUI2);

if (isActivePackage(UberAmmoPkg)) deactivatePackage(UberAmmoPkg);
activatePackage(UberAmmoPkg);

callback.add(onPlayGuiWake,UA_setupHuds);
callback.add(onCmdToggleHuds,UA_toggleHuds);
callback.add(MineUsed,UA_updateMines);
callback.add(MineReceived,UA_updateMines);
callback.add(GrenadeUsed,UA_updateGrens);
callback.add(GrenadeReceived,UA_updateGrens);
callback.add(GrenadeReceived,UA_updateGrenType);
callback.add(BeaconUsed,UA_updateBeacs);
callback.add(BeaconReceived,UA_updateBeacs);
callback.add(onToggleZoom,UA_hideOnZoom);
callback.add(PlayerDeath,UA_updateAll);